var Ctrl = enchant.Class.create({
	initialize: function (){
		this.game = null;
		this.menuBg = null;
		this.currentCommand = ECommand.WORLD_CURSOR;
		this.backgroundMap = null;
		this.player = null;
		this.objArray = {};
		this.def = null;
		this.objSprite = null;
		this.mangTouch = null;
		this.time = (HOUR * 24 + HOUR * 6) ;
		this.min = 0;
		this.hour = 0;
		this.day = 0;
		// this.popup = new GWindow(game.rootScene,0,0,100,100);
		this.popup = new GPopup(game.rootScene,0,0,100,100);
		// this.popup = new GWindow(this, {
		// 	x: 0,
		// 	y: 0,
		// 	width: 100,
		// 	height: 40,
		// 	color: "#ff0000",
		// });
		// this.popup.opacity = 0;
	},
	calcTime:function(){
		// var sec = ctl.time/BASE_FPS;
		var sec = ctl.time/BASE_FPS;
		this.min = Math.floor(sec % 60);
		var _min = sec / 60;
		this.hour = Math.floor(_min % 24);
		this.day = Math.floor(_min / 24 % 30);
	},
	init : function (game){
		this.game = game;
	},
	getDate : function(){
		if(this.hour >= 5 && this.hour < 11)return EDate.MORNING;
		if(this.hour >= 11 && this.hour < 13)return EDate.NOON;
		if(this.hour >= 13 && this.hour < 17)return EDate.AFTERNOON;
		if(this.hour >= 17 && this.hour < 20)return EDate.EVENING;
		if(this.hour >= 20 && this.hour < 24)return EDate.NIGHT;
		if(this.hour >= 0 && this.hour < 5)return EDate.MIDNIGHT;
	},
	setDefined:function(def){
		this.def = def;
	},
	addObj: function(obj){
		this.objArray[obj.id] = obj;
	},
	getObjs: function(){
		return this.objArray;
	},
	removeObj:function(obj){
		delete this.objArray[obj.id];
	},
	setMenuBg: function (menuBg){
		this.menuBg = menuBg;
	},
	setBackgroundMap: function(backgroundMap){
		this.backgroundMap = backgroundMap;
	},
	setPlayer: function(player){
		this.player = player;
	},
	setTime: function(time){
		this.time = time;
	},
	setCurrentObjSprite: function(objSprite){
		this.objSprite = objSprite;
	},
	getCurrentObjSprite: function(objSprite){
		return this.objSprite;
	},
	isCollision : function (e, node){
		var ex = e.x - ctl.backgroundMap.x;
		var ey = e.y - ctl.backgroundMap.y;
		if(node.getX() <= ex && node.getX() + node.getWidth() >= ex
			&& node.getY() <= ey && node.getY() + node.getHeight() >= ey){
			return true;
		}
		return false;
	},
	/**
	 * [setCurrentCommand description]
	 * @param {ECommand} cmd [description]
	 */
	setCurrentCommand: function(cmd){
		this.currentCommand = cmd;
	},
	getCurrentCommand: function(){
		return this.currentCommand;
	}
});
var CommandIcon = enchant.Class.create(enchant.Sprite,{
	initialize: function (x, y, ecmd, index){
		enchant.Sprite.call(this, x, y);
		this.ecmd = ecmd;
		this.index = index;
		this.text = "";
	},
	isCurrent: function(){
		return (this.index * 2)%2 !== 0;
	},
	setCurrent: function(){
		this.frame = (this.index * 2) + 1;
	},
	removeCurrent: function(){
		this.frame = (this.index * 2);
	}
});
var ICON_TEXT = [
"クリックアイコンです。\nフィールドのスクロールや\n各オブジェクトのステータスが見れます。",
"命令アイコンです。\nプレイヤーゆっくりに\n移動命令を出せます。",
"食物アイコンです。\nゆっくりが食べる\n食べ物を設置できます。",
"家アイコンです。\nゆっくりが住む事のできる\nプレイスを設置できます。",
"ゴミ箱アイコンです。\n配置したオブジェクトを削除できます。",
"しつけアイコンです。\nゆっくりに対してアクションが出来ます。",
];
var MangIcon = enchant.Class.create({
	initialize: function (ctl, menuBg){
		var self = this;
		this.ctl = ctl;
		this.cmdIcons = [];
		var index = 0;
		var POS_NUMBER = 4;
		var HEIGHT_TOP_MARGIN = 2;
		for (var key in ECommand) {
			var value = ECommand[key];
			this.cmdIcons[value] = new CommandIcon(ICON_WIDTH, ICON_HEIGHT, value, index);
			this.cmdIcons[value].image = this.ctl.game.assets[EResPath.COMMAND];
			this.cmdIcons[value].x = ICON_WIDTH * (index%POS_NUMBER) + 5;
			var yindex = parseInt(index/POS_NUMBER) + 1;
			this.cmdIcons[value].y = ICON_HEIGHT * yindex + HEIGHT_TOP_MARGIN;
			this.cmdIcons[value].text = ICON_TEXT[value];
			// odd equals current. even equals not current.
			this.cmdIcons[value].frame = (this.ctl.getCurrentCommand() == value)? index * 2 + 1: index * 2;
			menuBg.addChild(this.cmdIcons[value]);
			this.cmdIcons[value].ontouchstart = function(obj){
				// change command icons
				var nowECmd = self.ctl.getCurrentCommand();
				self.cmdIcons[nowECmd].removeCurrent();
				if(!this.isCurrent()){
					this.setCurrent();
				}
				self.ctl.setCurrentCommand(this.index);
			};
			index++;
		}
	},
	get: function(commandIndex){
		return this.cmdIcons[commandIndex];
	}
});
var ATouchEvent = enchant.Class.create({
	// initialize: function (ctl){
	//	this.ctl = ctl;
	// },
	touchstart: function(e){
	},
	touchmove: function(e){
	},
	touchend: function(e){
	}
});

var WorldCursorTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart : function(e){
		this.touchX = e.x - this.ctl.backgroundMap.x;
		this.touchY = e.y - this.ctl.backgroundMap.y;
		var tx = this.touchX;
		var ty = this.touchY;
		var nodes = this.ctl.getObjs();

		// nodes.sort(ctl.def.nodeSort);
		for (var id in nodes) {
			var node = nodes[id];
			if(node === null || node === undefined)continue;
			var nx = node.getX();
			var ny = node.getY();
			if(node == null)continue;
			if(node instanceof Box
				|| node instanceof this.ctl.def.Food
				|| node instanceof this.ctl.def.Unun
				){
				continue;
			}
			if(node instanceof this.ctl.def.Yukkuri){
				nx -= node.getWidth() / 2;
				ny -= node.getHeight() / 2;
			}
			if(	nx <= tx
				&& (nx + node.getWidth()) >= tx
				&& ny <= ty
				&& (ny + node.getHeight()) >= ty
				){
				// new BoxLabel(this.ctl,100, e.x, e.y);
				var box = new Box(this.ctl, node, e.x - ctl.backgroundMap.x, e.y - ctl.backgroundMap.y, 200, 200);
				box.drawBox();
				// var menuWindow = new MenuWindow(this.ctl, node, e.x, e.y, 300, 300);
				// menuWindow.draw();
				// new GWindow(game.rootScene,0,0,100,100);
				// ctl.popup.renew(game.rootScene,640,0,100,100);
				// ctl.popup.setText("aaaaaa");
				// ctl.popup.drawText();
				break;
			}
		}

	},
	touchmove : function(e){
		var backgroundMap = this.ctl.backgroundMap;
		var game = this.ctl.game;

		if(game.touched){
			backgroundMap.x = e.x - this.touchX;
			if(backgroundMap.x < -EFieldPos.WIDTH)backgroundMap.x = -EFieldPos.WIDTH;
			if(backgroundMap.x > 0)backgroundMap.x = 0;

			backgroundMap.y = e.y - this.touchY;
			if(backgroundMap.y < -EFieldPos.HEIGHT)backgroundMap.y = -EFieldPos.HEIGHT;
			if(backgroundMap.y > 0)backgroundMap.y = 0;
		}
		if(e.x > EFieldPos.WIDTH)game.touched = false;
		else if(e.x < 30)game.touched = false;
	},
	touchend : function(e){
	}
});
/**
 * プレイヤーゆっくりの移動を支持
 */
var WorldTargetTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart :function(e){
		if(e.x >= 0 && e.x <= EFieldPos.WIDTH){
			var backgroundMap = this.ctl.backgroundMap;
			addEffect(this.ctl.backgroundMap, -backgroundMap.x + e.x, -backgroundMap.y + e.y);
			this.ctl.player.tweet("ゆっくりりかいしたよ！");
			// var vx = (-backgroundMap.x + e.x) - this.ctl.player.getX() ;
			// var vy = (-backgroundMap.y + e.y) - this.ctl.player.getY() ;

			//移動先のx,y
			//action status
			//
			ctl.player.cmdQueue.push(new CommandQueueObject({
				touchX:(-backgroundMap.x + e.x),
				touchY:(-backgroundMap.y + e.y),
				date:ctl.getDate(),
				actionStatus:EAction.MOVE_TO_COMMAND
			}));
			// this.ctl.player.action.setStatus(EAction.MOVE_TO_COMMAND);
			// new MoveCommandEvent({
			// 	"vx": vx,
			// 	"vy": vy,
			// 	"action": this.ctl.player.action,
			// 	"myYukkuri": this.ctl.player
			// });

			// this.ctl.player.tweet("ゆー...いきたくないのぜ");
		}
	}
});
var WorldAppleTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart :function(e){
		if(e.x >= 0 && e.x <= EFieldPos.WIDTH){
			var backgroundMap = this.ctl.backgroundMap;
			var tx = -backgroundMap.x + e.x;
			var ty = -backgroundMap.y + e.y;
			// new ctl.def.Food("apple", tx, ty);
			new ctl.def.Food("grass", tx, ty);
		}
	}
});
var WorldPlaceTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart :function(e){
		if(e.x >= 0 && e.x <= EFieldPos.WIDTH){
			var backgroundMap = this.ctl.backgroundMap;
			var tx = -backgroundMap.x + e.x;
			var ty = -backgroundMap.y + e.y;
			new ctl.def.Place("tree", tx, ty);
		}
	}
});

var WorldRemoveTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart :function(e){
		this.touchX = e.x - this.ctl.backgroundMap.x;
		this.touchY = e.y - this.ctl.backgroundMap.y;
		var tx = this.touchX;
		var ty = this.touchY;
		var nodes = this.ctl.getObjs();
		// nodes.sort(ctl.def.nodeSort);
		for (var id in nodes) {
			var node = nodes[id];
			var nx = node.getX();
			var ny = node.getY();
			if(node == null)continue;
			// if(node instanceof Box
			// 	|| node instanceof this.ctl.def.Food
			// 	|| node instanceof this.ctl.def.Unun
			// 	){
			// 	continue;
			// }
			if(node instanceof this.ctl.def.Yukkuri){
				nx -= node.getWidth() / 2;
				ny -= node.getHeight() / 2;
			}
			if(	nx <= tx
				&& (nx + node.getWidth()) >= tx
				&& ny <= ty
				&& (ny + node.getHeight()) >= ty
				){
				if(node instanceof this.ctl.def.Yukkuri){
					mangMsg.output(node, EMsg.REMOVE_YUKKURI);
					node.setFaceImage(EFace.CRY1);
				}
				else if(node instanceof this.ctl.def.Place){
					node.removeAll();
				}
				else{
					node.removeAll();
					node.undefineAll();
				}

				break;
			}
		}
	}
});
var WorldPicoPicoHummerTouchEvent = enchant.Class.create(ATouchEvent,{
	initialize: function (ctl){
		this.ctl = ctl;
		this.touchX = 0;
		this.touchY = 0;
	},
	touchstart :function(e){
		this.touchX = e.x - this.ctl.backgroundMap.x;
		this.touchY = e.y - this.ctl.backgroundMap.y;
		var tx = this.touchX;
		var ty = this.touchY;
		var nodes = this.ctl.getObjs();
		// nodes.sort(ctl.def.nodeSort);
		for (var id in nodes) {
			var node = nodes[id];
			var nx = node.getX();
			var ny = node.getY();
			if(node == null)continue;
			if(!(node instanceof this.ctl.def.Yukkuri)){
				continue;
			}
			nx -= node.getWidth() / 2;
			ny -= node.getHeight() / 2;
			if(	nx <= tx
				&& (nx + node.getWidth()) >= tx
				&& ny <= ty
				&& (ny + node.getHeight()) >= ty
				){
				node.damage(EDamage.PICOHAN);

				break;
			}
		}
	}
});

var MangTouch = enchant.Class.create({
	initialize: function (ctl){
		this.ctl = ctl;
		var cursor = ECommand.WORLD_CURSOR;
		this.mang = {};
		this.mang[ECommand.WORLD_CURSOR] = new WorldCursorTouchEvent(ctl);
		this.mang[ECommand.WORLD_TARGET] = new WorldTargetTouchEvent(ctl);
		this.mang[ECommand.WORLD_APPLE] = new WorldAppleTouchEvent(ctl);
		this.mang[ECommand.WORLD_PLACE] = new WorldPlaceTouchEvent(ctl);
		this.mang[ECommand.WORLD_REMOVE] = new WorldRemoveTouchEvent(ctl);
		this.mang[ECommand.WORLD_PICOPICO_HUMMER] = new WorldPicoPicoHummerTouchEvent(ctl);
		ctl.mangTouch = this;
	},
	get: function(ecmd){
		return this.mang[ecmd];
	}
});
var MangLabel = enchant.Class.create({
	initialize: function (ctl, menuBg){
		this.ctl = ctl;
		var labelGroup = new LabelGroup();
		this.START_XPOS = 4;
		this.START_YPOS = GAME_HEIGHT / 2;
		this.GAUGE_XPOS = 80;
		this.menuBg = menuBg;
		this.widthArr = [];
		this.WIDTH_MARGIN = 4;
		this.GAUGE_HEIGHT = 16;
		var FONT = "18px 'Times New Roman'";
		var COLOR = "#ffffff";
		menuBg.image.context.font = FONT;
		var self = this;
		// this.labels = {};
		this.labelParams = {
			"yukkuri" : {
				label: null,
				init: function(){
					var TEXT = M.LABEL.YUKKURI;
					var label = new Label(TEXT);
					label.color = COLOR;
					label.font = FONT;
					label.x = self.START_XPOS;
					label.y = self.START_YPOS;
					label.textWidth = menuBg.image.context.measureText(TEXT).width;
					this.label = label;
				},
				draw: function(yukkuriObj){
					//100/maxhp*hp
					var gauge = 100 / yukkuriObj.param.maxYukkuri * yukkuriObj.param.yukkuri;
					self.menuBg.image.context.fillStyle = "#ffffff";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, 100, self.GAUGE_HEIGHT);
					self.menuBg.image.context.fillStyle = "#ff0000";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, gauge, self.GAUGE_HEIGHT);
				}
			},
			"hungry" : {
				label: null,
				init: function(){
					var TEXT = M.LABEL.HUNGRY;
					var label = new Label(TEXT);
					label.color = COLOR;
					label.font = FONT;
					label.x = self.START_XPOS;
					label.y = self.START_YPOS + 20;
					label.textWidth = menuBg.image.context.measureText(TEXT).width;
					this.label = label;
				},
				draw: function(yukkuriObj){
					var gauge =yukkuriObj.param.hungry;
					self.menuBg.image.context.fillStyle = "#ffffff";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, 100, self.GAUGE_HEIGHT);
					self.menuBg.image.context.fillStyle = "#bb7777";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, gauge, self.GAUGE_HEIGHT);
				}
			},
			"unun" : {
				label: null,
				init: function(){
					var TEXT = M.LABEL.UNUN;
					var label = new Label(TEXT);
					label.color = COLOR;
					label.font = FONT;
					label.x = self.START_XPOS;
					label.y = self.START_YPOS + 40;
					label.textWidth = menuBg.image.context.measureText(TEXT).width;
					this.label = label;
				},
				draw: function(yukkuriObj){
					var gauge =yukkuriObj.param.unun;
					self.menuBg.image.context.fillStyle = "#ffffff";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, 100, self.GAUGE_HEIGHT);
					self.menuBg.image.context.fillStyle = "#bb7777";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, gauge, self.GAUGE_HEIGHT);
				}
			},
			"sleep" : {
				label: null,
				init: function(){
					var TEXT = M.LABEL.SLEEP;
					var label = new Label(TEXT);
					label.color = COLOR;
					label.font = FONT;
					label.x = self.START_XPOS;
					label.y = self.START_YPOS + 60;
					label.textWidth = menuBg.image.context.measureText(TEXT).width;
					this.label = label;
				},
				draw: function(yukkuriObj){
					var gauge =yukkuriObj.param.sleep;
					self.menuBg.image.context.fillStyle = "#ffffff";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, 100, self.GAUGE_HEIGHT);
					self.menuBg.image.context.fillStyle = "#bb7777";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, gauge, self.GAUGE_HEIGHT);
				}
			},
			"stress" : {
				label: null,
				init: function(){
					var TEXT = M.LABEL.STRESS;
					var label = new Label(TEXT);
					label.color = COLOR;
					label.font = FONT;
					label.x = self.START_XPOS;
					label.y = self.START_YPOS + 80;
					label.textWidth = menuBg.image.context.measureText(TEXT).width;
					this.label = label;
				},
				draw: function(yukkuriObj){
					var gauge =yukkuriObj.param.stress;
					self.menuBg.image.context.fillStyle = "#ffffff";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, 100, self.GAUGE_HEIGHT);
					self.menuBg.image.context.fillStyle = "#bb7777";
					self.menuBg.image.context.fillRect(self.GAUGE_XPOS, this.label.y, gauge, self.GAUGE_HEIGHT);
				}
			},
		};

		this.menuBg.image.context.fillStyle = '#ff0000';
		for(var key in this.labelParams){
			var labelObj = this.labelParams[key];
			labelObj.init();
			labelGroup.addChild(labelObj.label);
		}
		menuBg.addChild(labelGroup);

		//datetime
		var dateLabel = new Label("時間");
		dateLabel.color = COLOR;
		dateLabel.font = FONT;
		dateLabel.x = self.START_XPOS;
		dateLabel.y = 4;
		// dateLabel.textWidth = menuBg.image.context.measureText(TEXT).width;
		dateLabel.addEventListener("enterframe", function(){
				// console.log("min:" + ctl.min + ":" + ctl.hour + ":" + ctl.day);
				this.text = "時間：" + ctl.day + "日 " + ctl.hour + ":" + ctl.min;
		});
		menuBg.addChild(dateLabel);

	},
	draw: function(yukkuriObj){
		for(var key in this.labelParams){
			var labelObj = this.labelParams[key];
			labelObj.draw(yukkuriObj);
		}
	}
});
var CommandQueueObject = enchant.Class.create({
	initialize: function (_data){
		this.touchX = _data.touchX;
		this.touchY = _data.touchY;
		this.date = _data.date;
		this.actionStatus = _data.actionStatus;
	}
});

var MangMsg = enchant.Class.create({
	initialize: function (ctl){
		this.ctl = ctl;
	},
	output:function(yukkuri, emsg, targetYukkuri){
		//var M = yukkuri.getMsg();
		var myCode = yukkuri.myCode;
		var mySize = yukkuri.mySize;
		if(myCode === null || myCode === undefined){
			myCode = "BASE";
			mySize = "L";
		}

		if(emsg == EMsg.WALK){
			if(rand(4) === 0){
				yukkuri.tweet(M.get(myCode,mySize,"WALK1"));
			}
			else if(rand(4) === 1){
				yukkuri.tweet(M.get(myCode,mySize,"WALK2"));
			}
			else if(rand(4) === 2){
				yukkuri.tweet(M.get(myCode,mySize,"WALK3"));
			}
			else if(rand(4) === 3){
				yukkuri.tweet(M.get(myCode,mySize,"WALK4"));
			}
		}
		else if(emsg == EMsg.EAT){
			if(rand(3) === 0){
				yukkuri.tweet(M.get(myCode,mySize,"EAT1"));
			}
			else if(rand(3) === 1){
				yukkuri.tweet(M.get(myCode,mySize,"EAT2"));
			}
			else if(rand(3) === 2){
				yukkuri.tweet(M.get(myCode,mySize,"EAT3"));
			}
		}
		else if(emsg == EMsg.GET_UP){
			yukkuri.tweet(M.get(myCode,mySize,"GET_UP1"));
		}
		else if(emsg == EMsg.SLEEP){
			yukkuri.tweet(M.get(myCode,mySize,"SLEEP1"));
		}
		else if(emsg == EMsg.DEAD){
			yukkuri.tweet(M.get(myCode,mySize,"DEAD1"));
		}
		else if(emsg == EMsg.UNUN){
			if(rand(2) === 0){
				yukkuri.tweet(M.get(myCode,mySize,"UNUN1"));
			}else{
				yukkuri.tweet(M.get(myCode,mySize,"UNUN2"));
			}
		}
		else if(emsg == EMsg.UNUN_END){
			yukkuri.tweet(M.get(myCode,mySize,"UNUN_END1"));
		}
		else if(emsg == EMsg.UNUN_SMELL){
			yukkuri.tweet(M.get(myCode,mySize,"UNUN_SPELL1"));
		}
		else if(emsg == EMsg.EAT_FAILED){
			yukkuri.tweet(M.get(myCode,mySize,"EAT_FAILED1"));
		}
		else if(emsg == EMsg.SAY_HELLO){

			if(yukkuri.getAddress(targetYukkuri) === null){
				yukkuri.tweet(M.get(myCode,mySize,"SAY_HELLO1"));
			}else{
				yukkuri.tweet(M.get(myCode,mySize,"SAY_HELLO2"));
			}
		}
		else if(emsg == EMsg.TARGETING_EAT){
			yukkuri.tweet(M.get(myCode,mySize,"TARGETING_EAT1"));
		}
		else if(emsg == EMsg.DECLARE_PLACE){
			yukkuri.tweet(M.get(myCode,mySize,"DECLARE_PLACE1"));
		}
		else if(emsg == EMsg.REHUNT){
			yukkuri.tweet(M.get(myCode,mySize,"REHUNT1"));
		}
		else if(emsg == EMsg.HUNT_ESCAPE){
			yukkuri.tweet(M.get(myCode,mySize,"HUNT_ESCAPE1"));
		}
		else if(emsg == EMsg.MOVE_GOTO_HOME){
			yukkuri.tweet(M.get(myCode,mySize,"MOVE_GOTO_HOME1"));
		}
		else if(emsg == EMsg.YYUYYU){
			if(rand(2) === 0){
				yukkuri.tweet(M.get(myCode,mySize,"YYUYYU1"));
			}else{
				yukkuri.tweet(M.get(myCode,mySize,"YYUYYU2"));
			}
		}
		else if(emsg == EMsg.HUNTING_MESSAGE){
			var num = rand(6) + 1;
			yukkuri.tweet(M.get(myCode,mySize,"HUNTING_MESSAGE" + num));
		}
		else if(emsg == EMsg.LEARN_NO_FOOD_IN_PLACE){
			var num = 1;
			yukkuri.tweet(M.get(myCode,mySize,"LEARN_NO_FOOD_IN_PLACE" + num));
		}
		else if(emsg == EMsg.REMOVE_YUKKURI){
			var num = 1;
			yukkuri.tweet(M.get(myCode,mySize,"REMOVE_YUKKURI" + num));
		}
		else if(emsg == EMsg.LOST_HOUSE){
			var num = 1;
			yukkuri.tweet(M.get(myCode,mySize,"LOST_HOUSE" + num));
		}
		else if(emsg == EMsg.MOVE_TO_HUNTING){
			var num = 1;
			yukkuri.tweet(M.get(myCode,mySize,"MOVE_TO_HUNTING" + num));
		}
		else if(emsg == EMsg.DAMAGE){
			var num = rand(1) + 1;
			yukkuri.tweet(M.get(myCode,mySize,"DAMAGE" + num));
		}

	}
});

// var MangLabel = enchant.Class.create({
//	initialize: function (ctl, menuBg){
//		this.ctl = ctl;
//		var labelGroup = new LabelGroup();
//		this.START_XPOS = 4;
//		this.START_YPOS = GAME_HEIGHT / 2;
//		this.menuBg = menuBg;
//		this.widthArr = [];
//		this.WIDTH_MARGIN = 4;
//		var FONT = "14px 'Times New Roman'";
//		var COLOR = "#ffffff";
//		menuBg.image.context.font = FONT;
//		var self = this;
//		this.labels = {
//			"yukkuri" : function(){
//				var TEXT = "ゆっくり";
//				var label = new Label(TEXT);
//				label.color = COLOR;
//				label.font = FONT;
//				label.x = self.START_XPOS;
//				label.y = self.START_YPOS;
//				label.textWidth = menuBg.image.context.measureText(TEXT).width;
//			},
//			"hungry" : function(){
//				var TEXT = "空腹";
//				var label = new Label(TEXT);
//				label.color = COLOR;
//				label.font = FONT;
//				label.x = self.START_XPOS;
//				label.y = self.START_YPOS + 20;
//				label.textWidth = menuBg.image.context.measureText(TEXT).width;
//				return label;
//			},
//		};

//		this.labels["yukkuri"]();
//		console.log(this.labels["yukkuri"]().textWidth);
//		// for(var key in this.labels){
//		//	console.log(key);
//		//	var label = this.labels[key]();
//		//	// labelGroup.addChild(label);
//		// }
//		// var width = this.widthArr['yukkuri'];
//		// this.menuBg.image.context.fillStyle = '#ff0000';
//		// this.menuBg.image.context.fillRect(this.START_XPOS + width, this.START_YPOS, 100, 30);
//		// menuBg.addChild(labelGroup);
//	},
//	draw: function(){
//		label = this.labels[key]();
//		this.menuBg.image.context.fillStyle = '#ff0000';
//		this.menuBg.image.context.fillRect(label.x, label.y, 100, 14);
//	}
// });

